<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: FreeRTOS.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">FreeRTOS.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * FreeRTOS.h</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> *  Created on: Feb 24, 2017</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *      Author: kolban</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;</div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#ifndef MAIN_FREERTOS_H_</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#define MAIN_FREERTOS_H_</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &lt;stdint.h&gt;</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &lt;pthread.h&gt;</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;</div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#include &lt;freertos/FreeRTOS.h&gt;</span>   <span class="comment">// Include the base FreeRTOS definitions.</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#include &lt;freertos/task.h&gt;</span>       <span class="comment">// Include the task definitions.</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#include &lt;freertos/semphr.h&gt;</span>     <span class="comment">// Include the semaphore definitions.</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#include &lt;freertos/ringbuf.h&gt;</span>    <span class="comment">// Include the ringbuffer definitions.</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;</div><div class="line"><a name="l00023"></a><span class="lineno"><a class="line" href="classFreeRTOS.html">   23</a></span>&#160;<span class="keyword">class </span><a class="code" href="classFreeRTOS.html">FreeRTOS</a> {</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classFreeRTOS.html#abea19fd141147c054f47c6a00e77f2ff">sleep</a>(uint32_t ms);</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classFreeRTOS.html#aaabf67574ec5a28c3db4536e200af576">startTask</a>(<span class="keywordtype">void</span> task(<span class="keywordtype">void</span>*), std::string taskName, <span class="keywordtype">void</span>* param = <span class="keyword">nullptr</span>, uint32_t stackSize = 2048);</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classFreeRTOS.html#a965b07cf1ca57fd0eb61df092b98edab">deleteTask</a>(TaskHandle_t pTask = <span class="keyword">nullptr</span>);</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;    <span class="keyword">static</span> uint32_t <a class="code" href="classFreeRTOS.html#aa2f4b1bd2944ae5e0c97a5dcbca65e66">getTimeSinceStart</a>();</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;</div><div class="line"><a name="l00031"></a><span class="lineno"><a class="line" href="classFreeRTOS_1_1Semaphore.html">   31</a></span>&#160;    <span class="keyword">class </span><a class="code" href="classFreeRTOS_1_1Semaphore.html">Semaphore</a> {</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;        <a class="code" href="classFreeRTOS_1_1Semaphore.html">Semaphore</a>(std::string owner = <span class="stringliteral">&quot;&lt;Unknown&gt;&quot;</span>);</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;        ~<a class="code" href="classFreeRTOS_1_1Semaphore.html">Semaphore</a>();</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;        <span class="keywordtype">void</span>        <a class="code" href="classFreeRTOS_1_1Semaphore.html#ad1aa158e37d15363b4441482fae82dd8">give</a>();</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;        <span class="keywordtype">void</span>        <a class="code" href="classFreeRTOS_1_1Semaphore.html#ad1aa158e37d15363b4441482fae82dd8">give</a>(uint32_t value);</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;        <span class="keywordtype">void</span>        <a class="code" href="classFreeRTOS_1_1Semaphore.html#a4446a195e3eee6704b4ad09528bedc0b">giveFromISR</a>();</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;        <span class="keywordtype">void</span>        <a class="code" href="classFreeRTOS_1_1Semaphore.html#a24047020ab820d4f641bc39bfab643df">setName</a>(std::string name);</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;        <span class="keywordtype">bool</span>        <a class="code" href="classFreeRTOS_1_1Semaphore.html#a67fa9bf777be48332a30154e006827fd">take</a>(std::string owner = <span class="stringliteral">&quot;&lt;Unknown&gt;&quot;</span>);</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;        <span class="keywordtype">bool</span>        <a class="code" href="classFreeRTOS_1_1Semaphore.html#a67fa9bf777be48332a30154e006827fd">take</a>(uint32_t timeoutMs, std::string owner = <span class="stringliteral">&quot;&lt;Unknown&gt;&quot;</span>);</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;        std::string <a class="code" href="classFreeRTOS_1_1Semaphore.html#a98e90c9cf596e4b214dd5a1c0ff745d7">toString</a>();</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;        uint32_t    <a class="code" href="classFreeRTOS_1_1Semaphore.html#a023cb404ff897bb39064b454732ccf21">wait</a>(std::string owner = <span class="stringliteral">&quot;&lt;Unknown&gt;&quot;</span>);</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    <span class="keyword">private</span>:</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;        SemaphoreHandle_t m_semaphore;</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;        pthread_mutex_t   m_pthread_mutex;</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;        std::string       m_name;</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;        std::string       m_owner;</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;        uint32_t          m_value;</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;        <span class="keywordtype">bool</span>              m_usePthreads;</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    };</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;};</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;</div><div class="line"><a name="l00059"></a><span class="lineno"><a class="line" href="classRingbuffer.html">   59</a></span>&#160;<span class="keyword">class </span><a class="code" href="classRingbuffer.html">Ringbuffer</a> {</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    <a class="code" href="classRingbuffer.html#a32e23dca7a30bc6d1d4b5c10ecbfbc52">Ringbuffer</a>(<span class="keywordtype">size_t</span> length, ringbuf_type_t type = RINGBUF_TYPE_NOSPLIT);</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;    ~<a class="code" href="classRingbuffer.html">Ringbuffer</a>();</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;    <span class="keywordtype">void</span>*    <a class="code" href="classRingbuffer.html#a2de1d3d2c869875883b351e66212dfef">receive</a>(<span class="keywordtype">size_t</span>* size, TickType_t wait = portMAX_DELAY);</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    <span class="keywordtype">void</span>     <a class="code" href="classRingbuffer.html#a145b135c71d2e715f13bdbe186e45cc6">returnItem</a>(<span class="keywordtype">void</span>* item);</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    <span class="keywordtype">bool</span>     <a class="code" href="classRingbuffer.html#ac4700ffc589022ed2dee5c069f583d7c">send</a>(<span class="keywordtype">void</span>* data, <span class="keywordtype">size_t</span> length, TickType_t wait = portMAX_DELAY);</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    RingbufHandle_t m_handle;</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;};</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* MAIN_FREERTOS_H_ */</span><span class="preprocessor"></span></div><div class="ttc" id="classRingbuffer_html_a2de1d3d2c869875883b351e66212dfef"><div class="ttname"><a href="classRingbuffer.html#a2de1d3d2c869875883b351e66212dfef">Ringbuffer::receive</a></div><div class="ttdeci">void * receive(size_t *size, TickType_t wait=portMAX_DELAY)</div><div class="ttdoc">Receive data from the buffer.</div><div class="ttdef"><b>Definition:</b> FreeRTOS.cpp:248</div></div>
<div class="ttc" id="classFreeRTOS_1_1Semaphore_html_a24047020ab820d4f641bc39bfab643df"><div class="ttname"><a href="classFreeRTOS_1_1Semaphore.html#a24047020ab820d4f641bc39bfab643df">FreeRTOS::Semaphore::setName</a></div><div class="ttdeci">void setName(std::string name)</div><div class="ttdoc">Set the name of the semaphore.</div><div class="ttdef"><b>Definition:</b> FreeRTOS.cpp:222</div></div>
<div class="ttc" id="classFreeRTOS_1_1Semaphore_html_a023cb404ff897bb39064b454732ccf21"><div class="ttname"><a href="classFreeRTOS_1_1Semaphore.html#a023cb404ff897bb39064b454732ccf21">FreeRTOS::Semaphore::wait</a></div><div class="ttdeci">uint32_t wait(std::string owner=&quot;&lt;Unknown&gt;&quot;)</div><div class="ttdoc">Wait for a semaphore to be released by trying to take it and then releasing it again.</div><div class="ttdef"><b>Definition:</b> FreeRTOS.cpp:68</div></div>
<div class="ttc" id="classRingbuffer_html_ac4700ffc589022ed2dee5c069f583d7c"><div class="ttname"><a href="classRingbuffer.html#ac4700ffc589022ed2dee5c069f583d7c">Ringbuffer::send</a></div><div class="ttdeci">bool send(void *data, size_t length, TickType_t wait=portMAX_DELAY)</div><div class="ttdoc">Send data to the buffer.</div><div class="ttdef"><b>Definition:</b> FreeRTOS.cpp:269</div></div>
<div class="ttc" id="classFreeRTOS_1_1Semaphore_html_ad1aa158e37d15363b4441482fae82dd8"><div class="ttname"><a href="classFreeRTOS_1_1Semaphore.html#ad1aa158e37d15363b4441482fae82dd8">FreeRTOS::Semaphore::give</a></div><div class="ttdeci">void give()</div><div class="ttdoc">Give a semaphore. The Semaphore is given.</div><div class="ttdef"><b>Definition:</b> FreeRTOS.cpp:118</div></div>
<div class="ttc" id="classRingbuffer_html_a145b135c71d2e715f13bdbe186e45cc6"><div class="ttname"><a href="classRingbuffer.html#a145b135c71d2e715f13bdbe186e45cc6">Ringbuffer::returnItem</a></div><div class="ttdeci">void returnItem(void *item)</div><div class="ttdoc">Return an item.</div><div class="ttdef"><b>Definition:</b> FreeRTOS.cpp:257</div></div>
<div class="ttc" id="classFreeRTOS_1_1Semaphore_html_a98e90c9cf596e4b214dd5a1c0ff745d7"><div class="ttname"><a href="classFreeRTOS_1_1Semaphore.html#a98e90c9cf596e4b214dd5a1c0ff745d7">FreeRTOS::Semaphore::toString</a></div><div class="ttdeci">std::string toString()</div><div class="ttdoc">Create a string representation of the semaphore.</div><div class="ttdef"><b>Definition:</b> FreeRTOS.cpp:211</div></div>
<div class="ttc" id="classRingbuffer_html_a32e23dca7a30bc6d1d4b5c10ecbfbc52"><div class="ttname"><a href="classRingbuffer.html#a32e23dca7a30bc6d1d4b5c10ecbfbc52">Ringbuffer::Ringbuffer</a></div><div class="ttdeci">Ringbuffer(size_t length, ringbuf_type_t type=RINGBUF_TYPE_NOSPLIT)</div><div class="ttdoc">Create a ring buffer.</div><div class="ttdef"><b>Definition:</b> FreeRTOS.cpp:232</div></div>
<div class="ttc" id="classRingbuffer_html"><div class="ttname"><a href="classRingbuffer.html">Ringbuffer</a></div><div class="ttdoc">Ringbuffer.</div><div class="ttdef"><b>Definition:</b> FreeRTOS.h:59</div></div>
<div class="ttc" id="classFreeRTOS_html_abea19fd141147c054f47c6a00e77f2ff"><div class="ttname"><a href="classFreeRTOS.html#abea19fd141147c054f47c6a00e77f2ff">FreeRTOS::sleep</a></div><div class="ttdeci">static void sleep(uint32_t ms)</div><div class="ttdef"><b>Definition:</b> FreeRTOS.cpp:27</div></div>
<div class="ttc" id="classFreeRTOS_html_aaabf67574ec5a28c3db4536e200af576"><div class="ttname"><a href="classFreeRTOS.html#aaabf67574ec5a28c3db4536e200af576">FreeRTOS::startTask</a></div><div class="ttdeci">static void startTask(void task(void *), std::string taskName, void *param=nullptr, uint32_t stackSize=2048)</div><div class="ttdef"><b>Definition:</b> FreeRTOS.cpp:39</div></div>
<div class="ttc" id="classFreeRTOS_1_1Semaphore_html_a4446a195e3eee6704b4ad09528bedc0b"><div class="ttname"><a href="classFreeRTOS_1_1Semaphore.html#a4446a195e3eee6704b4ad09528bedc0b">FreeRTOS::Semaphore::giveFromISR</a></div><div class="ttdeci">void giveFromISR()</div><div class="ttdoc">Give a semaphore from an ISR.</div><div class="ttdef"><b>Definition:</b> FreeRTOS.cpp:147</div></div>
<div class="ttc" id="classFreeRTOS_html_a965b07cf1ca57fd0eb61df092b98edab"><div class="ttname"><a href="classFreeRTOS.html#a965b07cf1ca57fd0eb61df092b98edab">FreeRTOS::deleteTask</a></div><div class="ttdeci">static void deleteTask(TaskHandle_t pTask=nullptr)</div><div class="ttdef"><b>Definition:</b> FreeRTOS.cpp:48</div></div>
<div class="ttc" id="classFreeRTOS_1_1Semaphore_html"><div class="ttname"><a href="classFreeRTOS_1_1Semaphore.html">FreeRTOS::Semaphore</a></div><div class="ttdef"><b>Definition:</b> FreeRTOS.h:31</div></div>
<div class="ttc" id="classFreeRTOS_html_aa2f4b1bd2944ae5e0c97a5dcbca65e66"><div class="ttname"><a href="classFreeRTOS.html#aa2f4b1bd2944ae5e0c97a5dcbca65e66">FreeRTOS::getTimeSinceStart</a></div><div class="ttdeci">static uint32_t getTimeSinceStart()</div><div class="ttdef"><b>Definition:</b> FreeRTOS.cpp:57</div></div>
<div class="ttc" id="classFreeRTOS_html"><div class="ttname"><a href="classFreeRTOS.html">FreeRTOS</a></div><div class="ttdoc">Interface to FreeRTOS functions.</div><div class="ttdef"><b>Definition:</b> FreeRTOS.h:23</div></div>
<div class="ttc" id="classFreeRTOS_1_1Semaphore_html_a67fa9bf777be48332a30154e006827fd"><div class="ttname"><a href="classFreeRTOS_1_1Semaphore.html#a67fa9bf777be48332a30154e006827fd">FreeRTOS::Semaphore::take</a></div><div class="ttdeci">bool take(std::string owner=&quot;&lt;Unknown&gt;&quot;)</div><div class="ttdoc">Take a semaphore. Take a semaphore and wait indefinitely.</div><div class="ttdef"><b>Definition:</b> FreeRTOS.cpp:163</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.15
</small></address>
</body>
</html>
